#pragma once

#include "CoreMinimal.h"
#include "InteractionDefinition.h"
#include "K40SecurityCameraInteraction.generated.h"

class AK40SecurityCamera;
class ADBDPlayer;

UCLASS(Blueprintable, EditInlineNew, meta=(BlueprintSpawnableComponent))
class UK40SecurityCameraInteraction : public UInteractionDefinition
{
	GENERATED_BODY()

private:
	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _cameraBlendTime;

	UPROPERTY(ReplicatedUsing=OnRep_CurrentlyViewCamera, Transient)
	TWeakObjectPtr<AK40SecurityCamera> _currentlyViewedCamera;

	UPROPERTY(Transient)
	TWeakObjectPtr<ADBDPlayer> _interactingPlayer;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _inputAbsoluteTolerance;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, meta=(AllowPrivateAccess=true))
	float _inputAbsoluteResetTolerance;

private:
	UFUNCTION()
	void OnRep_CurrentlyViewCamera(TWeakObjectPtr<AK40SecurityCamera> oldViewedCamera);

public:
	virtual void GetLifetimeReplicatedProps(TArray<FLifetimeProperty>& OutLifetimeProps) const override;

public:
	UK40SecurityCameraInteraction();
};

FORCEINLINE uint32 GetTypeHash(const UK40SecurityCameraInteraction) { return 0; }
